/* Client remote_sort*/

#include<stdio.h>
#include<fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#define DIM_BUFF 256

main(int argc, char *argv[])
{
 int sd, fd, fd_ord, nread;
 char buff[DIM_BUFF];
 int fromlen, conn_ok;
 struct hostent *host;    /*ptr a info per host remoto*/
 struct sockaddr_in rem_indirizzo; /*per indirizzo socket remota*/

 if(argc!=4) { 
	printf("Error:%s server file_da_ord file_dest_ord\n", argv[0]);
	exit(1);
 }
 memset ((char *)&rem_indirizzo, 0, sizeof(struct sockaddr_in));
 	/* Preparazione indirizzo remoto a cui connettersi */
 rem_indirizzo.sin_family = AF_INET;
 host = gethostbyname(argv[1]);
 if (host == NULL) {
        printf("%s not found in /etc/hosts\n", argv[1]);
        exit(1);
 }
 rem_indirizzo.sin_addr.s_addr=((struct in_addr*)
(host->h_addr))->s_addr;
 rem_indirizzo.sin_port = 12347; /*possibile uso htons()*/

 sd=socket(AF_INET, SOCK_STREAM, 0);
 printf("Client: creata la socket sd=%d\n", sd);
 conn_ok=connect(sd,(struct sockaddr *) &rem_indirizzo, sizeof(struct sockaddr));
if(conn_ok<0) { 
	perror("Errore in connect"); exit(1);
 }
else printf("Client: connect ok\n");

 if ((nread=read(sd, buff, DIM_BUFF))<0) {perror("read"); exit(1);}

 if(buff[0]=='S') {
	if((fd=open(argv[2], O_RDONLY))<0) {perror("open"); exit(1); }
	if((fd_ord=open(argv[3], O_WRONLY|O_CREAT, 0644))<0) {
		perror("open"); exit(1); 
 	}
	printf("Client: stampo e invio file da ordinare\n");
 	while((nread=read(fd, buff, DIM_BUFF))>0){	
		write(1,buff,nread);
		write(sd,buff,nread);
	}
	printf("Client: file inviato\n");
 	shutdown(sd,1); 
	printf("Client: ricevo e stampo file ordinato\n");
	while((nread=read(sd,buff,DIM_BUFF))>0){
	 	write(fd_ord,buff,nread);
		write(1,buff,nread);
	}

 } else printf("Client: non sono autorizzato \n");
 close(sd); exit(0);
}

