
/* Server */

#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#define MAX_DIM 20

main(argc, argv)
int argc;
char **argv;
{
int  sock, retval, addrlen;
char buff[MAX_DIM];
struct sockaddr_in mio_indirizzo;  /* local socket address */
struct sockaddr_in indirizzo_client;  /* peer socket address */

memset ((char *)&mio_indirizzo, 0, sizeof(struct sockaddr_in));
memset ((char *)&indirizzo_client, 0, sizeof(struct sockaddr_in));

/* inizializzazione mio indirizzo */	
mio_indirizzo.sin_family=AF_INET;
mio_indirizzo.sin_port=22375;

sock=socket(AF_INET, SOCK_DGRAM, 0);
if(sock<0) {perror("apertura socket"); exit(1);}
else printf("Server: creata la socket sd=%d\n", sock);

if(bind(sock, (struct sockaddr *)&mio_indirizzo, sizeof(struct sockaddr_in))<0) {
perror("bind"); exit(1); 
}
else printf("Server: bind ok\n");

for (;;) {
  recvfrom(sock, buff, MAX_DIM, 0, (struct sockaddr *)&indirizzo_client, &addrlen); 
  write(1, buff, strlen(buff));
  printf("\n");
}
close(sock);
exit(0);
}

