/* Client */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

main(argc, argv)
int argc;
char **argv;
{ 
struct hostent *host;	/*ptr a info per host remoto*/
struct sockaddr_in indirizzo_server; /*per indirizzo socket remota*/
int  sock, i, lun;

memset((char *)&indirizzo_server, 0, sizeof(struct sockaddr_in));

sock=socket(AF_INET, SOCK_DGRAM, 0);
if(sock<0) {perror("apertura socket"); exit(1);}
printf("Client: creata la socket sd=%d\n", sock);

indirizzo_server.sin_family = AF_INET;
for (i=1; i<=argc-2; i++) {
	host = gethostbyname (argv[i]);
	if (host == NULL) {
		printf("%s not found in /etc/hosts\n", argv[i]);
		exit(2);
	}
	else {
		printf("Client: indirizzo server n. %d: %s \n", i, host->h_name);
		indirizzo_server.sin_addr.s_addr=((struct in_addr *)(host->h_addr))->s_addr;
		indirizzo_server.sin_port = 22375;
		sendto(sock, argv[argc-1], (strlen(argv[argc-1]) + 1), 0, (struct sockaddr *)&indirizzo_server, sizeof(struct sockaddr_in));
		printf("Client: inviato msg %s \n", argv[argc-1]);	
	}
} /*end for*/
close(sock);
exit(0);
}
